<?php
/********************************************************************************
* RenameTopic.php                                                               *
* ----------------------------------------------------------------------------- *
* This is where you add, edit and delete Global Announcements.                  *
*********************************************************************************
* Software version:               Rename Topic 0.1                              *
* Software by:                    Juan "JayBachatero" Hernandez                 *
* Copyright (c) 2006 by:          Juan "JayBachatero" Hernandez                 *
* Contact:                        Jay@JayBachatero.com                          *
* Website:                        JayBachatero.com                              *
* ============================================================================= *
* This mod is free software; you may redistribute it and/or modify it as long   *
* as you credit me for the original mod. This mod is distributed in the hope    *
* that it is and will be useful, but WITHOUT ANY WARRANTIES; without even any   *
* implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.      *
*                                                                               *
* All SMF copyrights are still in effect. Anything not mine is theirs. Enjoy!   *
* Some code found in here is copy written code by SMF, therefore it can not be  *
* redistributed without official consent from myself or SMF.                    *
********************************************************************************/

if (!defined('SMF'))
	die ('Hacking attempt...');

function RenameTopic()
{
	global $db_prefix, $txt, $func, $context, $sourcedir;

	// Check if allowed to renameTopic.
	isAllowedTo('rename_topic');

	// Load the template.
	loadTemplate('RenameTopic');

	// Check if a topic id is set.
	if (!isset($_REQUEST['topic']) || is_array($_REQUEST['topic']))
		fatal_lang_error('rename_topic_no_id');

	// Load Subs-Post.php
	require_once($sourcedir . '/Subs-Post.php');

	// Define ID_TOPIC.
	$ID_TOPIC = (int)$_REQUEST['topic'];

	// Select the current subject.
	$selectSubject = db_query("
		SELECT subject
		FROM {$db_prefix}messages
		WHERE ID_TOPIC = '$ID_TOPIC'
		LIMIT 1", __FILE__, __LINE__);

	// List the result.
	list ($currentSubject) = mysql_fetch_row($selectSubject);
	mysql_free_result($selectSubject);

	// Stripslashes and htmlspecialchars
	$context['currentSubject'] = strtr(censorText(stripslashes($currentSubject)), array("\r" => '', "\n" => '', "\t" => ''));

	// If renameTopic isset do the renaming.
	if (isset($_POST['renameTopic2']) && !empty($_POST['subject']))
	{
		// Check if they have a valid session.
		checkSession();

		// Clean the new subject.
		$_POST['subject'] = strtr(htmlspecialchars($_POST['subject']), array("\r" => '', "\n" => '', "\t" => ''));
		
		// At this point, we want to make sure the subject isn't too long.
		if (strlen($_POST['subject']) > 100)
			$_POST['subject'] = addslashes(substr(stripslashes($_POST['subject']), 0, 100));

		// Make sure the subject fits in the tinytext of the database.
		if (strlen($_POST['subject']) > 255)
			$_POST['subject'] = addslashes(truncate(stripslashes($_POST['subject']), 255));

		// Do the dew.
		$update = db_query("
			UPDATE {$db_prefix}messages
			SET
				subject = '$_POST[subject]'
			WHERE ID_TOPIC = '$ID_TOPIC'", __FILE__, __LINE__);

		// Check if it went through.  If so redirect.
		if ($update == true)
			redirectexit('topic=' . $ID_TOPIC);
		else
			redirectexit('action=renameTopic;topic=' . $ID_TOPIC);
	}

	// Set the title.
	$context['page_title'] = $txt['rename_topic'];
	
}
?>
